using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

static class Program
{ [STAThread] static void Main() { Game1 game = new Game1(); game.Run(); }

public class Game1 : Microsoft.Xna.Framework.Game
{ private GraphicsDeviceManager g;
  private Model model;
  private BasicEffect effect;
  private float trans             = 0,
                transIncrement    = 0.02f,
                zoom              = 1, 
                zoomIncrement     = 0.005f,
                rotation          = 0,
                rotationIncrement = 0.01f;  
  public Game1()
  { g = new GraphicsDeviceManager( this );
  }
  protected override void Initialize()
  { g.PreferredBackBufferWidth  = 600;
    g.PreferredBackBufferHeight = 600;
    g.ApplyChanges();
    Window.Title = "Tiger Rotation";
    Window.AllowUserResizing = true;
    base.Initialize();
  }
  protected override void LoadContent()
  { model = Content.Load< Model >("Content\\tiger");
    effect = (BasicEffect)model.Meshes[0].Effects[0];
    effect.View = Matrix.CreateLookAt( new Vector3( 0f, 0f, 4f ), 
                                       Vector3.Zero, Vector3.Up );
    effect.Projection = Matrix.CreatePerspectiveFieldOfView
                               ( MathHelper.Pi/4, 1f, 1f, 100000f );
  }
protected override void Draw( GameTime gameTime )
  { //g.GraphicsDevice.RenderState.FillMode = FillMode.WireFrame;
    g.GraphicsDevice.Clear( Color.DarkBlue );
    if ( trans < -0.8f | trans > 0.8f ) transIncrement *= -1f;
    if ( zoom  <  0.1f | zoom  > 1.2f ) zoomIncrement  *= -1f;
    trans    += transIncrement;
    zoom     += zoomIncrement;
    rotation += rotationIncrement;
    effect.World  = Matrix.CreateScale      ( zoom        );
    effect.World *= Matrix.CreateRotationX  ( rotation    );
    effect.World *= Matrix.CreateRotationY  ( rotation    );
    effect.World *= Matrix.CreateRotationZ  ( rotation    );
    effect.World *= Matrix.CreateTranslation( trans, 0, 0 );
    model.Meshes[0].Draw();
  }
} // end of class Game1
} // end of class Program